/*
 * Icons Bibliothek
 * HeatBox
 * (c) hadi-rc.de
 *
 * Hier werden die Muster für verschiedene Symbole erstellt.
 * Das verwendete LCD-Display (besser gesagt, der Controller) bietet die Möglichkeit,
 * bis zu 8 eigene Symbole in den RAM des Display-Controllers zu laden.
 * Diese Möglichkeit benutzen wir für kleine Grafiken, oder um z.B. das "Grad"-Symbol zur Verfügung zu haben.
 *
 */






const uint8_t gradcelsiusIcon[8] PROGMEM = {   //GRAD-Zeichen
  B01000,
  B10100,
  B01000,
  B00011,
  B00100,
  B00100,
  B00100,
  B00011
};

const uint8_t thermometerIcon[8] PROGMEM = {   //Thermoter-Zeichen
  B10001,
  B11001,
  B10001,
  B11001,
  B10001,
  B11111,
  B11111,
  B01110
};


const uint8_t batterieIcon[8] PROGMEM = {   //Halbvolle-Batterie-Zeichen
  B01110,
  B10001,
  B10011,
  B10111,
  B11111,
  B11111,
  B11111,
  B11111
};

const uint8_t batterieLeerIcon[8] PROGMEM = {   //Leere-Batterie-Zeichen
  B01110,
  B10001,
  B10001,
  B10001,
  B10001,
  B10001,
  B10001,
  B11111
};

const uint8_t spannungIcon[8] PROGMEM = {   //Spannung-Zeichen
  B00100,
  B00100,
  B11111,
  B00000,
  B01110,
  B00100,
  B00100,
  B00100
};



const uint8_t zieltemperaturIcon[8] PROGMEM = {   //Zieltemperatur-Zeichen
  B11111,
  B00100,
  B01110,
  B11111,
  B00100,
  B00100,
  B00100
};



const uint8_t rightIcon[8] PROGMEM = {   //Uhr-Zeichen
  B10000,
  B11000,
  B11100,
  B11110,
  B11110,
  B11100,
  B11000,
  B10000
};

const uint8_t leftIcon[8] PROGMEM = {   //Thermoter-Zeichen
  B00001,
  B00011,
  B00111,
  B01111,
  B01111,
  B00111,
  B00011,
  B00001
};

/*
const uint8_t thermometer[8] PROGMEM = {   //Thermoter-Zeichen
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
  B00000
};
*/
