
struct tMenuItem {
  const __FlashStringHelper* text;
  tMenuItem* next;
  tMenuItem* prev;
  tMenuItem* subMenu;
  void* value;
  byte type;
  unsigned int maxWert;
  unsigned int minWert;
} defaultscreen, premenu1, premenu2, premenu3, premenu4, premenu5,
setup1, setup2, setup3, setup4, setup5, setup6, setup7, setup8, setup9, 
temp1, temp2, temp3, temp4, 
batt1, batt2, batt3, batt4, batt5, batt6, batt7, batt8,
heiz1, heiz2, heiz3, heiz4,
vent1, vent2, vent3,
sonst1, sonst2, sonst3, sonst4, sonst5,
info1, info2, info3, info4,
bestaetigeReset, timerEinstellen1, timerEinstellen2, timerEinstellen3, timerEinstellen4;



tMenuItem* currentItem;





void setupMenu() {
  
  premenu1.text    =F("   Reset Akku");
  premenu1.next    =(tMenuItem*)&premenu2;
  premenu1.prev    =(tMenuItem*)&premenu5;
  premenu1.subMenu =(tMenuItem*)&bestaetigeReset;
  premenu1.value   =NULL;
  premenu1.type    =0;
  
      bestaetigeReset.text    =F("    wirklich?");
      bestaetigeReset.next    =&bestaetigeReset;
      bestaetigeReset.prev    =&bestaetigeReset;
      bestaetigeReset.subMenu =NULL;
      bestaetigeReset.value   =&verbrauchZuruecksetzen;
      bestaetigeReset.type    =2;   
  

  premenu2.text    =F("   Timer Setup");
  premenu2.next    =(tMenuItem*)&premenu3;
  premenu2.prev    =(tMenuItem*)&premenu1;
  premenu2.subMenu =(tMenuItem*)&timerEinstellen1;
  premenu2.value   =NULL;
  premenu2.type    =0;
  
      timerEinstellen1.text    =F(" Countdown-Zeit");
      timerEinstellen1.next    =&timerEinstellen2;
      timerEinstellen1.prev    =&timerEinstellen1;    //KEin Übergang zum Ende gewünscht
      timerEinstellen1.subMenu =NULL;
      timerEinstellen1.value   =&countdownZeitStunden;
      timerEinstellen1.type    =8;
      timerEinstellen1.minWert =0;
      timerEinstellen1.maxWert =23;
      
      timerEinstellen2.text    =timerEinstellen1.text;
      timerEinstellen2.next    =&timerEinstellen3;
      timerEinstellen2.prev    =&timerEinstellen1;
      timerEinstellen2.subMenu =NULL;
      timerEinstellen2.value   =&countdownZeitMinuten;
      timerEinstellen2.type    =9;
      timerEinstellen2.minWert =0;
      timerEinstellen2.maxWert =59;
      
      timerEinstellen3.text    =F("Mit Warmhalten?");
      timerEinstellen3.next    =&timerEinstellen4;
      timerEinstellen3.prev    =&timerEinstellen2;
      timerEinstellen3.subMenu =NULL;
      timerEinstellen3.value   =&countdownMitHeizen;
      timerEinstellen3.type    =2;

      
      
      timerEinstellen4.text    =F("Start Countdown?");
      timerEinstellen4.next    =&timerEinstellen4;    //Kein Übergang zum Anfang gewünscht
      timerEinstellen4.prev    =&timerEinstellen3;
      timerEinstellen4.subMenu =NULL;
      timerEinstellen4.value   =&starteCountdown;
      timerEinstellen4.type    =2;

  
  premenu3.text    =F("  System Setup");
  premenu3.next    =(tMenuItem*)&premenu4;
  premenu3.prev    =(tMenuItem*)&premenu2;
  premenu3.subMenu =(tMenuItem*)&setup1;
  premenu3.value   =NULL;
  premenu3.type    =0;
  
  premenu4.text    =F("      Info");
  premenu4.next    =(tMenuItem*)&premenu5;
  premenu4.prev    =(tMenuItem*)&premenu3;
  premenu4.subMenu =(tMenuItem*)&info1;
  premenu4.value   =NULL;
  premenu4.type    =0;
  
  premenu5.text    =F("     Beenden");
  premenu5.next    =(tMenuItem*)&premenu1;
  premenu5.prev    =(tMenuItem*)&premenu4;
  premenu5.subMenu =(tMenuItem*)&defaultscreen;
  premenu5.value   =NULL;
  premenu5.type    =0;

 

  setup1.text    =F("  Temperaturen");
  setup1.next    =(tMenuItem*)&setup2;
  setup1.prev    =(tMenuItem*)&setup9;
  setup1.subMenu =(tMenuItem*)&temp1;
  setup1.value   =NULL;
  setup1.type    =0;
  
      temp1.text    =F(" Zieltemperatur");
      temp1.next    =(tMenuItem*)&temp2;
      temp1.prev    =(tMenuItem*)&temp4;
      temp1.subMenu =NULL;
      temp1.value   =&hbtempsettings.zieltemperatur;
      temp1.type    =0;
      temp1.minWert =20;
      temp1.maxWert =60;

      temp2.text    =F("    Hysterese");
      temp2.next    =(tMenuItem*)&temp3;
      temp2.prev    =(tMenuItem*)&temp1;
      temp2.subMenu =NULL;
      temp2.value   =&hbtempsettings.hysterese;
      temp2.type    =0;
      temp2.minWert =1;
      temp2.maxWert =10;

      temp3.text    =F("Countdown-Temp");
      temp3.next    =(tMenuItem*)&temp4;
      temp3.prev    =(tMenuItem*)&temp2;
      temp3.subMenu =NULL;
      temp3.value   =&hbtempsettings.warmhalteTemperatur;
      temp3.type    =0;
      temp3.minWert =20;
      temp3.maxWert =60;

      temp4.text    =F("     Zurueck");
      temp4.next    =(tMenuItem*)&temp1;
      temp4.prev    =(tMenuItem*)&temp3;
      temp4.subMenu =(tMenuItem*)&setup1;
      temp4.value   =NULL;
      temp4.type    =0;
  
  
  setup2.text    =F("    Batterie");
  setup2.next    =(tMenuItem*)&setup3;
  setup2.prev    =(tMenuItem*)&setup1;
  setup2.subMenu =(tMenuItem*)&batt1;
  setup2.value   =NULL;
  setup2.type    =0;
  
      batt1.text    =F("   Batterietyp");
      batt1.next    =(tMenuItem*)&batt2;
      batt1.prev    =(tMenuItem*)&batt8;
      batt1.subMenu =NULL;
      batt1.value   =&hbtempsettings.batterietyp;
      batt1.type    =6;
      batt1.minWert =0;
      batt1.maxWert =(anzahlAkkuTypen-1);
      
      batt2.text    =F("  Anzahl Zellen");
      batt2.next    =(tMenuItem*)&batt3;
      batt2.prev    =(tMenuItem*)&batt1;
      batt2.subMenu =NULL;
      batt2.value   =&hbtempsettings.zellenzahl;
      batt2.type    =7;
      batt2.minWert =0;
      batt2.maxWert =8;
     
      batt3.text    =F("   Kapazitaet");
      batt3.next    =(tMenuItem*)&batt4;
      batt3.prev    =(tMenuItem*)&batt2;
      batt3.subMenu =NULL;
      batt3.value   =&hbtempsettings.kapazitaet;
      batt3.type    =1;  
      batt3.minWert =100;
      batt3.maxWert =40000;
      
      batt4.text    =F(" Abschaltgrenze");
      batt4.next    =(tMenuItem*)&batt5;
      batt4.prev    =(tMenuItem*)&batt3;
      batt4.subMenu =NULL;
      batt4.value   =&hbtempsettings.abschaltgrenze;
      batt4.type    =1;
      batt4.minWert =80;
      batt4.maxWert =40000;
  
      batt5.text    =F(" Zusatz-Warnung");
      batt5.next    =(tMenuItem*)&batt6;
      batt5.prev    =(tMenuItem*)&batt4;
      batt5.subMenu =NULL;
      batt5.value   =&hbtempsettings.sollWarnen;
      batt5.type    =2;
      
      batt6.text    =F("  Warnschwelle");
      batt6.next    =(tMenuItem*)&batt7;
      batt6.prev    =(tMenuItem*)&batt5;
      batt6.subMenu =NULL;
      batt6.value   =&hbtempsettings.warnschwelle;
      batt6.type    =1; 
      batt6.minWert =60;
      batt6.maxWert =40000;
 
      batt7.text    =F("Verbrauch merken");
      batt7.next    =(tMenuItem*)&batt8;
      batt7.prev    =(tMenuItem*)&batt6;
      batt7.subMenu =NULL;
      batt7.value   =&hbtempsettings.sollSpeichern;
      batt7.type    =2; 

      batt8.text    = temp4.text; //=F("     Zurueck    ");
      batt8.next    =(tMenuItem*)&batt1;
      batt8.prev    =(tMenuItem*)&batt7;
      batt8.subMenu =(tMenuItem*)&setup2;
      batt8.value   =NULL;
      batt8.type    =0;   
      
      
  setup3.text    =F("     Heizung");
  setup3.next    =(tMenuItem*)&setup4;
  setup3.prev    =(tMenuItem*)&setup2;
  setup3.subMenu =(tMenuItem*)&heiz1;
  setup3.value   =NULL;
  setup3.type    =0;
  
      heiz1.text    =F("    Heizdauer");
      heiz1.next    =(tMenuItem*)&heiz2;
      heiz1.prev    =(tMenuItem*)&heiz4;
      heiz1.subMenu =NULL;
      heiz1.value   =&hbtempsettings.heizungLaufdauer;
      heiz1.type    =4;
      heiz1.minWert =15;
      heiz1.maxWert =60;
  
      heiz2.text    =F("   Pausendauer");
      heiz2.next    =(tMenuItem*)&heiz3;
      heiz2.prev    =(tMenuItem*)&heiz1;
      heiz2.subMenu =NULL;
      heiz2.value   =&hbtempsettings.heizungPausedauer;
      heiz2.type    =4;
      heiz2.minWert =0;
      heiz2.maxWert =20;
  
      heiz3.text    =F("   PWM Boost");
      heiz3.next    =(tMenuItem*)&heiz4;
      heiz3.prev    =(tMenuItem*)&heiz2;
      heiz3.subMenu =NULL;
      heiz3.value   =&hbtempsettings.pwmboost;
      heiz3.type    =5;
      heiz3.minWert =0;
      heiz3.maxWert =20;
  
      heiz4.text    =temp4.text;//=F("     Zurueck    ");
      heiz4.next    =(tMenuItem*)&heiz1;
      heiz4.prev    =(tMenuItem*)&heiz3;
      heiz4.subMenu =(tMenuItem*)&setup3;
      heiz4.value   =NULL;
      heiz4.type    =0; 
  
  setup4.text    =F("   Ventilator");
  setup4.next    =(tMenuItem*)&setup5;
  setup4.prev    =(tMenuItem*)&setup3;
  setup4.subMenu =(tMenuItem*)&vent1;
  setup4.value   =NULL;
  setup4.type    =0;
  
      vent1.text    =F("    Laufdauer");
      vent1.next    =(tMenuItem*)&vent2;
      vent1.prev    =(tMenuItem*)&vent3;
      vent1.subMenu =NULL;
      vent1.value   =&hbtempsettings.ventilatorLaufdauer;
      vent1.type    =4;
      vent1.minWert =10;
      vent1.maxWert =60;
      
      vent2.text    =heiz2.text;//=F("   Pausendauer  ");
      vent2.next    =(tMenuItem*)&vent3;
      vent2.prev    =(tMenuItem*)&vent1;
      vent2.subMenu =NULL;
      vent2.value   =&hbtempsettings.ventilatorPausedauer;
      vent2.type    =4;
      vent2.minWert =10;
      vent2.maxWert =60;
  
      vent3.text    =temp4.text;//=F("     Zurueck    ");
      vent3.next    =(tMenuItem*)&vent1;
      vent3.prev    =(tMenuItem*)&vent2;
      vent3.subMenu =(tMenuItem*)&setup4;
      vent3.value   =NULL;
      vent3.type    =0;  

  setup5.text    =F("   Sonstiges");
  setup5.next    =(tMenuItem*)&setup6;
  setup5.prev    =(tMenuItem*)&setup4;
  setup5.subMenu =(tMenuItem*)&sonst1;
  setup5.value   =NULL;
  setup5.type    =0;
  
      sonst1.text    =F(" Ton bei Alarm");
      sonst1.next    =(tMenuItem*)&sonst2;
      sonst1.prev    =(tMenuItem*)&sonst5;
      sonst1.subMenu =NULL;
      sonst1.value   =&hbtempsettings.alarmTon;
      sonst1.type    =2;
      
      sonst2.text    =F(" LED Helligkeit");
      sonst2.next    =(tMenuItem*)&sonst3;
      sonst2.prev    =(tMenuItem*)&sonst1;
      sonst2.subMenu =NULL;
      sonst2.value   =&hbtempsettings.displayHelligkeit;
      sonst2.type    =10;
      sonst2.minWert =1;
      sonst2.maxWert =10;

      sonst3.text    =F("  LED Dauer-An");
      sonst3.next    =(tMenuItem*)&sonst4;
      sonst3.prev    =(tMenuItem*)&sonst2;
      sonst3.subMenu =NULL;
      sonst3.value   =&hbtempsettings.displayDauerAn;
      sonst3.type    =2;

      sonst4.text    =F("V Kalibrierung");
      sonst4.next    =(tMenuItem*)&sonst5;
      sonst4.prev    =(tMenuItem*)&sonst3;
      sonst4.subMenu =NULL;
      sonst4.value   =&hbtempsettings.kalibrierWert;
      sonst4.type    =11;
      sonst4.minWert =0;
      sonst4.maxWert =30;

      sonst5.text    =temp4.text;//=F("     Zurueck    ");
      sonst5.next    =(tMenuItem*)&sonst1;
      sonst5.prev    =(tMenuItem*)&sonst4;
      sonst5.subMenu =(tMenuItem*)&setup5;
      sonst5.value   =NULL;
      sonst5.type    =0;        

  setup6.text    =F("Speichern & Ende");
  setup6.next    =(tMenuItem*)&setup7;
  setup6.prev    =(tMenuItem*)&setup5;
  setup6.subMenu =NULL;
  setup6.value   =&speichereAktuelleWerte;
  setup6.type    =2;
  
  setup7.text    =F(" vorherige Werte");
  setup7.next    =(tMenuItem*)&setup8;
  setup7.prev    =(tMenuItem*)&setup6;
  setup7.subMenu =NULL;
  setup7.value   =&setzeVorherigeWerte;
  setup7.type    =2;
  
  setup8.text    =F(" Standard-Werte");
  setup8.next    =(tMenuItem*)&setup9;
  setup8.prev    =(tMenuItem*)&setup7;
  setup8.subMenu =NULL;
  setup8.value   =&setzeStandartWerte;
  setup8.type    =2;

  setup9.text    =temp4.text;//=F("     Zurueck    ");
  setup9.next    =(tMenuItem*)&setup1;
  setup9.prev    =(tMenuItem*)&setup8;
  setup9.subMenu =(tMenuItem*)&premenu3;
  setup9.value   =NULL;
  setup9.type    =0;



  info1.text    =F("Firmware Version");
  info1.next    =&info2;
  info1.prev    =&info4;
  info1.subMenu =NULL;
  info1.value   =(void*)&hbVersionString;
  info1.type    =20;

  info2.text    =F("Made");
  info2.next    =&info3;
  info2.prev    =&info1;
  info2.subMenu =NULL;
  info2.value   =(void*)&hbVendorString;
  info2.type    =20;

  info3.text    =F("Geraeteinfo");
  info3.next    =&info4;
  info3.prev    =&info2;
  info3.subMenu =NULL;
  info3.value   =(void*)&deviceInfoString;
  info3.type    =20; 

  info4.text    =temp4.text; //=F("     Zurueck    ");
  info4.next    =&info1;
  info4.prev    =&info3;
  info4.subMenu =&premenu4;
  info4.value   =NULL;
  info4.type    =0;
  
}




