/*
Viele Wörter und Zeichen benutzen wir im Code mehrmals.
Hier legen wir ein mal diese Wörter im PROGMEM an und
können sie dann später wiederverwenden anstatt sie für jede
Verwendung neu anzulegen.
*/

const __FlashStringHelper* leer16Zeichen;
const __FlashStringHelper* wortTempSens;
const __FlashStringHelper* wortSpannung;
const __FlashStringHelper* wortFehler;
const __FlashStringHelper* nummerNull;
const __FlashStringHelper* externeQuelle;

void ladeGemeinsameWoerter(){
  leer16Zeichen = F("                ");
  wortTempSens  = F("TempSens");
  wortSpannung  = F("spannung");
  wortFehler    = F("Fehler");
  nummerNull    = F("0");
  externeQuelle  = F("Externe Quelle");
}
